#include <stdio.h>
#include <math.h>

/* Zbog koristenja math.h, pod Linuxom se ovo compilira s dodatnim parametrom -lm */

typedef struct {
  double x0, y0, x1, y1;
} duzina;

double zad3b(duzina d) {
  return sqrt(pow(d.x0 - d.x1, 2) + pow(d.y0 - d.y1, 2));
}

void zad3c(duzina *d) {
  d->x0 = 2 - d->x0;
  d->x1 = 2 - d->x1;
}

void zad3d(duzina d[], int n) {
  int i, j;
  for (i = 0; i < n; ++i)
    for (j = i + 1; j < n; ++j)
      if (zad3b(d[i]) > zad3b(d[j])) {
        duzina tmp = d[i];
        d[i] = d[j];
        d[j] = tmp;
      }
}

void ispis_duzine(duzina d) {
  printf("(%g,%g)--(%g,%g)", d.x0, d.y0, d.x1, d.y1);
}

void ispis_niza(duzina d[], int n) {
  int i;
  for (i = 0; i < n; ++i) {
    printf("  %d: ", i+1);
    ispis_duzine(d[i]);
    printf("\t%g\n", zad3b(d[i]));
  }
}

int main(void) {
  duzina d = {2.0, 17.0, 5.0, 13.0}; /* |x1-x0|=3, |y1-y0|=4 => Pitagorini brojevi => duljina je 5 */
  duzina niz[] = {{-31.0, -2.0, 29.0, -13.0}, d, {0.0, 5.0, 7.0, 29.0}, {4.0, -5.0, -1.0, 7.0}};
  int n = sizeof(niz) / sizeof(duzina);

  printf("Prije simetrije:\n");
  printf("  d = "); ispis_duzine(d); printf(", |d| = %g\n", zad3b(d));
  zad3c(&d);
  printf("Nakon simetrije:\n");
  printf("  d = "); ispis_duzine(d); printf(", |d| = %g\n", zad3b(d));

  printf("Niz prije sorta:\n");
  ispis_niza(niz, n);
  zad3d(niz, n);
  printf("Niz nakon sorta:\n");
  ispis_niza(niz, n);

  return 0;
}
