#include <stdio.h>
#include <math.h>

/* Zbog koristenja math.h, pod Linuxom se ovo compilira s dodatnim parametrom -lm */

typedef struct {
  double x1, y1, x2, y2;
} pravokutnik;

double zad3b(pravokutnik p) {
  return fabs((p.x1 - p.x2) * (p.y1 - p.y2));
}

void zad3c(pravokutnik *p, double a, double b) {
  p->x1 = 2 * a - p->x1;
  p->y1 = 2 * b - p->y1;
  p->x2 = 2 * a - p->x2;
  p->y2 = 2 * b - p->y2;
}

void zad3d(pravokutnik p[], int n) {
  int i, j;
  for (i = 0; i < n; ++i)
    for (j = i + 1; j < n; ++j)
      if (zad3b(p[i]) < zad3b(p[j])) {
        pravokutnik tmp = p[i];
        p[i] = p[j];
        p[j] = tmp;
      }
}

void ispis_pravokutnika(pravokutnik p) {
  printf("(%g,%g)--(%g,%g)", p.x1, p.y1, p.x2, p.y2);
}

void ispis_niza(pravokutnik p[], int n) {
  int i;
  for (i = 0; i < n; ++i) {
    printf("  %d: ", i+1);
    ispis_pravokutnika(p[i]);
    printf("\t%g\n", zad3b(p[i]));
  }
}

int main(void) {
  pravokutnik p = {2.0, 13.0, 5.0, 17.0}; /* |x1-x0|=3, |y1-y0|=4 => povrsina je 12 */
  pravokutnik niz[] = {{-31.0, -2.0, 29.0, -13.0}, p, {0.0, 5.0, 7.0, 29.0}, {4.0, -5.0, -1.0, 7.0}};
  int n = sizeof(niz) / sizeof(pravokutnik);
  struct { double a, b; } t = {1.0, -2.0};

  printf("Prije simetrije oko tocke (%g,%g):\n", t.a, t.b);
  printf("  p = "); ispis_pravokutnika(p); printf(", P(p) = %g\n", zad3b(p));
  zad3c(&p, t.a, t.b);
  printf("Nakon simetrije oko tocke (%g,%g):\n", t.a, t.b);
  printf("  p = "); ispis_pravokutnika(p); printf(", P(p) = %g\n", zad3b(p));

  printf("Niz prije sorta:\n");
  ispis_niza(niz, n);
  zad3d(niz, n);
  printf("Niz nakon sorta:\n");
  ispis_niza(niz, n);

  return 0;
}
