#include <stdio.h>
#include <math.h>

/* Zbog koristenja math.h, pod Linuxom se ovo compilira s dodatnim parametrom -lm */

typedef struct {
  double x, y, a;
} kvadrat;

/* Funkcija zad3b(), kako je definirana u zadatku, zapravo tretira tocku (x,y) kao najblizu
   ishodistu, a ne nuzno donju lijevu. Zadano je kako je zadano zbog jednostavnosti. */

double zad3b(kvadrat k) {
  return sqrt(pow(k.x + k.a/2, 2) + pow(k.y + k.a/2, 2));
}

void zad3c(kvadrat *k, double x1, double y1) {
  k->x = x1 - k->a/2;
  k->y = y1 - k->a/2;
}

void zad3d(kvadrat k[], int n) {
  int i, j;
  for (i = 0; i < n; ++i)
    for (j = i + 1; j < n; ++j)
      if (zad3b(k[i]) > zad3b(k[j])) {
        kvadrat tmp = k[i];
        k[i] = k[j];
        k[j] = tmp;
      }
}

void ispis_kvadrata(kvadrat k) {
  printf("[(%g,%g), %g]", k.x, k.y, k.a);
}

void ispis_niza(kvadrat k[], int n) {
  int i;
  for (i = 0; i < n; ++i) {
    printf("  %d: ", i+1);
    ispis_kvadrata(k[i]);
    printf("\t%g\n", zad3b(k[i]));
  }
}

int main(void) {
  kvadrat k = {-3.0, -2.0, 12.0}; /* |x+a/2|=3, |y+a/2|=4 => Pitagorini brojevi => udaljenost je 5 */
  kvadrat niz[] = {{-31.0, -2.0, 29.0}, k, {0.0, 5.0, 17.0}, {4.0, -5.0, 1.0}};
  int n = sizeof(niz) / sizeof(kvadrat);
  struct { double a, b; } t = {1.0, -2.0};

  printf("Prije premjestanja na tocku (%g,%g):\n", t.a, t.b);
  printf("  p = "); ispis_kvadrata(k); printf(", d(O,k) = %g\n", zad3b(k));
  zad3c(&k, t.a, t.b);
  printf("Nakon premjestanja na tocku (%g,%g):\n", t.a, t.b);
  printf("  p = "); ispis_kvadrata(k); printf(", d(O,k) = %g\n", zad3b(k));

  printf("Niz prije sorta:\n");
  ispis_niza(niz, n);
  zad3d(niz, n);
  printf("Niz nakon sorta:\n");
  ispis_niza(niz, n);

  return 0;
}
